C# · 12月 21, 2021

处理异常的 try,catch

try
catch
finally

1、将预见可能引发异常的代码包含在try语句块中。
2、如果发生了异常,则转入catch的执行。catch有几种写法:
catch
这将捕获任何发生的异常。
catch(Exception e)
这将捕获任何发生的异常。另外,还提供e参数,你可以在处理异常时使用e参数来获得有关异常的信息。
catch(Exception的派生类 e)
这将捕获派生类定义的异常,例如,我想捕获一个无效操作的异常,可以如下写:
catch(InvalidOperationException e)
{
    ….
}
这样,如果try语句块中抛出的异常是InvalidOperationException,将转入该处执行,其他异常不处理。

catch可以有多个,也可以没有,每个catch可以处理一个特定的异常。.net按照你catch的顺序查找异常处理块,如果找到,则进行处理,如果找不到,则向上一层次抛出。如果没有上一层次,则向用户抛出,此时,如果你在调试,程序将中断运行,如果是部署的程序,将会中止。

如果没有catch块,异常总是向上层(如果有)抛出,或者中断程序运行。

3、finally
finally可以没有,也可以只有一个。无论有没有发生异常,它总会在这个异常处理结构的最后运行。即使你在try块内用return返回了,在返回前,finally总是要执行,这以便让你有机会能够在异常处理最后做一些清理工作。如关闭数据库连接等等。
注意:如果没有catch语句块,那么finally块就是必须的。
如果你不希望在这里处理异常,而当异常发生时提交到上层处理,但在这个地方无论发生异常,都要必须要执行一些操作,就可以使用try finally,
很典型的应用就是进行数据库操作:
用下面这个原语来说明:
try
{
    DataConnection.open();
    DataCommand.ExecuteReader();
    …
    return;
}
finally
{
    DataConnection.Close();
}

无论是否抛出异常,也无论从什么地方return返回,finally语句块总是会执行,这样你有机会调用Close来关闭数据库连接(即使未打开或打开失败,关闭操作永远是可以执行的),以便于释放已经产生的连接,释放资源。
顺便说明,return是可以放在try语句块中的。但不管在什么时机返回,在返回前,finally将会执行。
小结
try { //执行的代码,其中可能有异常。一旦发现异常,则立即跳到catch执行。否则不会执行catch里面的内容 }

catch { //除非try里面执行代码发生了异常,否则这里的代码不会执行 }

finally { //不管什么情况都会执行,包括try catch 里面用了return,可以理解为只要执行了try或者catch,就一定会执行 finally }

一,

如何:使用 Try/Catch 块捕捉异常<p align="left">将可能引发异常的代码节放在 Try 块中,而将处理异常的代码放在 Catch 块中。Catch 块是一系列以关键字 catch 开头的语句,语句后跟异常类型和要执行的操作。

<p align="left">下面的代码示例使用 Try/Catch 块捕捉可能的异常。Main 方法包含带有 StreamReader 语句的 Try 块,该语句打开名为 data.txt 的数据文件并从该文件写入字符串。Try 块后面是 Catch 块,该块捕捉 Try 块产生的任何异常。

<p align="left"> 

<p align="left">using System;

<p align="left">using System.IO;

<p align="left">using System.Security.Permissions;

<p align="left">// Security permission request.

<p align="left">[assembly:FileIOPermissionAttribute(SecurityAction.RequestMinimum,All = @"c:\data.txt")]

<p align="left">public class ProcessFile {

<p align="left">    public static void Main() {

<p align="left">        try {

<p align="left">            StreamReader sr = File.OpenText("data.txt");

<p align="left">            Console.WriteLine("The first line of this file is {0}",sr.ReadLine());   

<p align="left">        }

<p align="left">        catch(Exception e) {

<p align="left">            Console.WriteLine("An error occurred: '{0}'",e);

<p align="left">        }

<p align="left">    }

<p align="left">}

<p align="left">二,

如何:在 Catch 块中使用特定异常

发生异常时,异常沿堆栈向上传递,每个 Catch 块都有机会处理它。Catch 语句的顺序很重要。将针对特定异常的 Catch 块放在常规异常 Catch 块的前面,否则编译器可能会发出错误。确定正确 Catch 块的方法是将异常的类型与 Catch 块中指定的异常名称进行匹配。如果没有特定的 Catch 块,则由可能存在的常规 Catch 块捕捉异常。

 

下面的代码示例使用 try/catch 块捕获 InvalidCastException。该示例创建一个名为 Employee 的类,它带有一个属性:职员级别 (Emlevel)。PromoteEmployee 方法取得对象并增加职员级别。将 DateTime 实例传递给 PromoteEmployee 方法时,发生 InvalidCastException。

 

using System;

public class Employee

{

   //Create employee level property.

   public int Emlevel

   {

      get

         {

         return(emlevel);

         }

      set

         {

         emlevel = value;

         }

   }

   int emlevel;

}

public class Ex13

{

   public static void PromoteEmployee(Object emp)

   {

   //Cast object to Employee.

   Employee e = (Employee) emp;

   // Increment employee level.

   e.Emlevel = e.Emlevel + 1;

   }

 

   public static void Main()

   {

   try

      {

   Object o = new Employee();

   DateTime newyears = new DateTime(2001,1,1);

   //Promote the new employee.

   PromoteEmployee(o);

   //Promote DateTime; results in InvalidCastException as newyears is not an employee instance.

   PromoteEmployee(newyears);

      }

   catch (InvalidCastException e)

      {

      Console.WriteLine(“Error passing data to PromoteEmployee method. ” + e);

      }

   }

}

三,

如何:显式引发异常

可以使用 throw 语句显式引发异常。还可以使用 throw 语句再次引发捕获的异常。较好的编码做法是,向再次引发的异常添加信息以在调试时提供更多信息。

 

下面的代码示例使用 try/catch 块捕获可能的 FileNotFoundException。try 块后面是 catch 块,catch 块捕获 FileNotFoundException,如果找不到数据文件,则向控制台写入消息。下一条语句是 throw 语句,该语句引发新的 FileNotFoundException 并向该异常添加文本信息。

 

using System;

using System.IO;

 

public class ProcessFile

{

   public static void Main()

      {

      FileStream fs = null;

      try  

      {

         //Opens a text tile.

         fs = new FileStream(@”C:\temp\data.txt”,FileMode.Open);

         StreamReader sr = new StreamReader(fs);

         string line;

 

         //A value is read from the file and output to the console.

         line = sr.ReadLine();

         Console.WriteLine(line);

      }

      catch(FileNotFoundException e)

      {

         Console.WriteLine(“[Data File Missing] {0}”,e);

         throw new FileNotFoundException(@”data.txt not in c:\temp directory]”,e);

      }

      finally

      {

         if (fs != null)

            fs.Close();

      }

   }

}

四,

如何:使用 Finally 块

异常发生时,执行将终止,并且控制交给最近的异常处理程序。这通常意味着不执行希望总是调用的代码行。有些资源清理(如关闭文件)必须总是执行,即使有异常发生。为实现这一点,可以使用 Finally 块。Finally 块总是执行,不论是否有异常发生。

 

下面的代码示例使用 try/catch 块捕获 ArgumentOutOfRangeException。Main 方法创建两个数组并试图将一个数组复制到另一个数组。该操作生成 ArgumentOutOfRangeException,同时错误被写入控制台。Finally 块执行,不论复制操作的结果如何。

using System;

class ArgumentOutOfRangeExample

{

         static public void Main()

  {

  int[] array1={0,0};

  int[] array2={0,0};

     try

     {

     Array.Copy(array1,array2,-1);

     }

     catch (ArgumentOutOfRangeException e)

     {

     Console.WriteLine(“Error: {0}”,e);

     }

     finally

     {

     Console.WriteLine(“This statement is always executed.”);

     }

  }

}